local t = Def.ActorFrame {};

-- Players
for p in ivalues(PlayerNumber) do
	local eval_part_offs = string.find(p, "P1") and -310 or 310
	if GAMESTATE:IsHumanPlayer(p) then
		t[#t+1] =  Def.ActorFrame{
			InitCommand=function(self)
				self:vertalign(top):x(_screen.cx + eval_part_offs):y(SCREEN_TOP)
			end;
			  -- Bar
			  Def.Quad {
				InitCommand=function(self) 
					self:zoomto(336,61):vertalign(top) 
					self:diffuse(PlayerColor(p)):diffuserightedge(PlayerCompColor(p)):diffusealpha(0.96)
				end;
				OnCommand=function(self) self:zoomto(336,0):sleep(0.5):decelerate(0.7):zoomto(336,61) end;
				OffCommand=function(self) self:sleep(0.175):decelerate(0.4):addy(-105) end;
			 };
			 -- Avatar and name
			Def.ActorFrame {
				OnCommand=function(self) 
					self:diffusealpha(0):sleep(0.5+0.7):decelerate(0.2):diffusealpha(1) 
				end;
				Def.Sprite {
					InitCommand=function(self) self:horizalign(left):vertalign(top):xy(-164,5) end;
					Texture=LoadModule("Options.GetProfileData.lua")(p)["Image"];
					OnCommand=function(self)
						self:zoomto(52,52)
					end;
					OffCommand=function(self) self:decelerate(0.2):diffusealpha(0) end;
				};
				Def.BitmapText {
					Font="_plex sans medium 24px";
					InitCommand=function(self)
						self:horizalign(left):xy(-100,30):maxwidth(220):skewx(-0.15):queuecommand("Set")
					end;
					OnCommand=function(self) self:diffuse(ColorDarkTone(PlayerDarkColor(p))) end;	
					SetCommand=function(self)
						self:settext(LoadModule("Options.GetProfileData.lua")(p)["Name"])
					end;
					OffCommand=function(self) self:decelerate(0.2):diffusealpha(0) end;
				};
			};
		};
	end;
end;

if not GAMESTATE:IsCourseMode() then
	t[#t+1] = Def.ActorFrame {
		LoadActor(THEME:GetPathG("ScreenEvaluation", "StageDisplay")) .. {
			InitCommand=function(self) self:x(SCREEN_CENTER_X):y(SCREEN_TOP+84):visible(not GAMESTATE:HasEarnedExtraStage()) end;
			OnCommand=function(self) self:diffusealpha(0):sleep(0.3):decelerate(0.4):diffusealpha(1) end;
			OffCommand=function(self) self:sleep(0.175):decelerate(0.4):diffusealpha(0) end;
		}
	}
else
	t[#t+1] =  Def.ActorFrame {
		InitCommand=function(self) self:x(SCREEN_CENTER_X):y(SCREEN_TOP+84) end;
		OnCommand=function(self) self:diffusealpha(0):sleep(0.3):decelerate(0.4):diffusealpha(1) end;
		OffCommand=function(self) self:sleep(0.175):decelerate(0.4):diffusealpha(0) end;
				Def.BitmapText {
				Font="_plex sans Bold 24px";
				InitCommand=function(self) self:y(-1):zoom(1):shadowlength(1):uppercase(true) end;
				BeginCommand=function(self)
					self:playcommand("Set")
				end;
				CurrentSongChangedMessageCommand=function(self)
					self:playcommand("Set")
				end;
				SetCommand=function(self)
					local curStage = GAMESTATE:GetCurrentStage();
					local course = GAMESTATE:GetCurrentCourse()
					self:settext(string.upper(ToEnumShortString( course:GetCourseType() )))
					-- StepMania is being stupid so we have to do this here;
					self:diffuse(StageToColor(curStage)):diffusetopedge(ColorLightTone(StageToColor(curStage)));
					self:diffusealpha(0):smooth(0.3):diffusealpha(1);
				end;
			};
	}
end;

	
if GAMESTATE:HasEarnedExtraStage() then
	t[#t+1] =  Def.ActorFrame {
		InitCommand=function(self) self:x(SCREEN_CENTER_X):y(SCREEN_TOP+84) end;
		OnCommand=function(self) self:diffusealpha(0):sleep(0.3):decelerate(0.4):diffusealpha(1) end;
		OffCommand=function(self) self:sleep(0.175):decelerate(0.4):diffusealpha(0) end;
			Def.BitmapText {
				Font="_plex sans medium 24px";
				InitCommand=function(self) self:y(-1):zoom(1):shadowlength(1):uppercase(true):maxwidth(250) end;
				BeginCommand=function(self)
					self:playcommand("Set")
				end;
				CurrentSongChangedMessageCommand=function(self)
					self:playcommand("Set")
				end;
				SetCommand=function(self)
					local curStage = GAMESTATE:GetCurrentStage();
					local text = string.upper(THEME:GetString("ScreenEvaluation", "ExtraUnlocked"))
					self:settext(text)
					-- StepMania is being stupid so we have to do this here;
					self:diffuse(ColorLightTone(StageToColor(curStage)));
					self:diffusealpha(0):smooth(0.3):diffusealpha(1);
				end;
			};
		};
end;

return t;
