local barSleepIn = 0.9
local songAreaWidth = SCREEN_WIDTH*0.4375
local t = Def.ActorFrame {
	-- Global message caller for all the things
    OnCommand=function(self) MESSAGEMAN:Broadcast("Set") end;
    CurrentStepsP1ChangedMessageCommand=function(self) MESSAGEMAN:Broadcast("Set") end;
    CurrentStepsP2ChangedMessageCommand=function(self) MESSAGEMAN:Broadcast("Set") end;
	CurrentTrailP1ChangedMessageCommand=function(self) MESSAGEMAN:Broadcast("Set") end;
	CurrentTrailP2ChangedMessageCommand=function(self) MESSAGEMAN:Broadcast("Set") end;
    CurrentCourseChangedMessageCommand=function(self) MESSAGEMAN:Broadcast("Set") end;
    CurrentSongChangedMessageCommand=function(self) MESSAGEMAN:Broadcast("Set") end;
};
-- Progress bar function
local function UpdateTime(self)
	local c = self:GetChildren();
	for pn in ivalues(PlayerNumber) do
		local vStats = STATSMAN:GetCurStageStats():GetPlayerStageStats( pn );
		local vTime;
		local obj = self:GetChild( string.format("RemainingTime" .. PlayerNumberToString(pn) ) );
		if vStats and obj then
			vTime = vStats:GetLifeRemainingSeconds()
			obj:settext( SecondsToMMSSMsMs( vTime ) );
		end;
	end;
end
local function songMeterScale(val) return scale(val,0,1,-380/2,380/2) end	

local function GetPlScore(pl, scoretype)
	local primary_score = STATSMAN:GetCurStageStats():GetPlayerStageStats(pl):GetScore()
	local secondary_score = FormatPercentScore(STATSMAN:GetCurStageStats():GetPlayerStageStats(pl):GetPercentDancePoints())

	if PREFSMAN:GetPreference("PercentageScoring") then
		primary_score, secondary_score = secondary_score, primary_score
	end

	if scoretype == "primary" then
		return primary_score
	else
		return secondary_score
	end
end

	if GAMESTATE:IsHumanPlayer(PLAYER_1) then
		t[#t+1] = LoadModule("Options.SmartToastieActors.lua")(1)
	end
	
	if GAMESTATE:IsHumanPlayer(PLAYER_2) then
		t[#t+1] = LoadModule("Options.SmartToastieActors.lua")(2)
	end

	t[#t+1] = Def.ActorFrame {
		OnCommand=function(self) self:addy(-75):sleep(barSleepIn):decelerate(0.5):addy(75) end;
		OffCommand=function(self) self:sleep(0.15):decelerate(0.3):addy(-75) end;
		Def.Quad {
			InitCommand=function(self)
				self:xy(0,0):vertalign(top):horizalign(left):zoomto(SCREEN_WIDTH,56) 
			end;
			OnCommand=function(self)
				self:diffuse(color("#0E1A3A")):diffusealpha(0.72)
			end;
		};	
		-- Colors for each player
		Def.ActorFrame {
			OnCommand=function(self) 
				self:diffusealpha(0):sleep(barSleepIn+0.8):linear(0.2):diffusealpha(0.9):decelerate(2):diffusealpha(0.7)
			end;
			Def.Quad {
				InitCommand=function(self) 
					self:visible(GAMESTATE:IsHumanPlayer(PLAYER_1)):x(SCREEN_LEFT):y(0):vertalign(top):horizalign(left):zoomto(320,56)
					self:diffuse(ColorMidTone(PlayerColor(PLAYER_1))):faderight(1)
				end
			};		
			Def.Quad {
				InitCommand=function(self) 
					self:visible(GAMESTATE:IsHumanPlayer(PLAYER_2)):x(SCREEN_RIGHT):y(0):vertalign(top):horizalign(right):zoomto(320,56)
					self:diffuse(ColorMidTone(PlayerColor(PLAYER_2))):fadeleft(1)
				end
			};
		};
		-- Song title area
		Def.ActorFrame {
				Def.Quad {
					InitCommand=function(self) self:vertalign(top):horizalign(center):xy(SCREEN_CENTER_X,0):fadetop(1):zoomto(0,56) end;
					OnCommand=function(self)
						self:sleep(barSleepIn+0.3):decelerate(0.6):zoomto(songAreaWidth,56)
					end;
					SetMessageCommand=function(self)
						local curStage = GAMESTATE:GetCurrentStage();
						self:diffuse(StageToColor(curStage)):diffusealpha(0.3);
					end;
				};

			-- Song meter
			Def.ActorFrame {
			OnCommand=function(self)
				self:diffuseshift():effectclock("beat"):effectcolor1(color("1,1,1,0.5")):effectcolor2(color("1,1,1,0.8"))
			end;		
				Def.Quad {
					InitCommand=function(self)
						self:xy(SCREEN_CENTER_X,56):vertalign(bottom):horizalign(center) 
					end;
					OnCommand=function(self)
						self:zoomto(0,7):sleep(barSleepIn+0.3):decelerate(0.6):zoomto(songAreaWidth,7)
					end;
					SetMessageCommand=function(self)
						local curStage = GAMESTATE:GetCurrentStage();
						self:diffuse(ColorDarkTone((StageToColor(curStage)))):diffusealpha(0.5);
					end;		
				};	
			};
			Def.SongMeterDisplay {
				InitCommand=function(self) self:xy(SCREEN_CENTER_X,56):vertalign(bottom):horizalign(center) end;
				StreamWidth=songAreaWidth;
				Stream=LoadActor( THEME:GetPathG( 'SongMeterDisplay', 'stream') )..{
					InitCommand=function(self)
						self:vertalign(bottom):diffusealpha(0.4):zoomy(0.5)
					end;
				};
				Tip=LoadActor( THEME:GetPathG( 'SongMeterDisplay', 'tip')) .. { 
					InitCommand=function(self)
						self:vertalign(bottom):visible(false)
					end;
				};
			};
			--- Song info
			Def.BitmapText {
				Font="_plex sans Bold 24px";
				InitCommand=function(self)
					self:x(SCREEN_CENTER_X+(SCREEN_WIDTH*0.21)):y(26):zoom(0.8):maxwidth(SCREEN_WIDTH*0.421875):diffuse(color("#FFFFFF")):horizalign(right)
				end;
				OnCommand=function(self)
					self:diffusealpha(0):sleep(barSleepIn+0.3+0.9):decelerate(0.7):diffusealpha(0.75)
				end;
				SetMessageCommand=function(self)
					   local song = GAMESTATE:GetCurrentSong();
					   if song then
							self:settext(song:GetDisplayMainTitle());
							self:playcommand("Refresh");
						else
							self:settext("");
							self:playcommand("Refresh");
					   end
						if song:GetDisplaySubTitle() ~= "" then
							self:y(22)
						else
							self:y(26)
						end;
				  end;
			};
			Def.BitmapText {
				Font="_plex sans condensed medium 24px";
				InitCommand=function(self)
					self:x(SCREEN_CENTER_X+(SCREEN_WIDTH*0.21)):y(26+14):zoom(0.5):maxwidth(SCREEN_WIDTH*0.578125):diffuse(color("#FFFFFF")):horizalign(right)
				end;
				OnCommand=function(self)
					self:diffusealpha(0):sleep(barSleepIn+0.3+0.9):decelerate(0.7):diffusealpha(0.75)
				end;
				SetMessageCommand=function(self)
					   local song = GAMESTATE:GetCurrentSong();
					   if song then
							self:settext(song:GetDisplaySubTitle());
							self:playcommand("Refresh");
						else
							self:settext("");
							self:playcommand("Refresh");
					   end
				  end;
			};
			--- Stage
			Def.ActorFrame {
				InitCommand=function(self)
					self:y(26):diffuse(color("#FFFFFF")):horizalign(right)
						if IsWidescreen() == true then
							self:x(SCREEN_CENTER_X-(SCREEN_WIDTH*0.18))
						else
							self:x(SCREEN_CENTER_X-(SCREEN_WIDTH*0.17))
						end;
				end;
				OnCommand=function(self)
					self:diffusealpha(0):sleep(barSleepIn+0.3+0.7):decelerate(0.7):diffusealpha(0.75)
				end;
					Def.BitmapText {
					Font="_plex sans Bold 24px";
					InitCommand=function(self)
						self:y(-7):maxwidth(88):uppercase(true):skewx(-0.15)
					end;
					SetMessageCommand=function(self)
						local curScreen = Var "LoadingScreen";
						local curStageIndex = GAMESTATE:GetCurrentStageIndex() + 1;
						local playMode = GAMESTATE:GetPlayMode();
						local curStage = GAMESTATE:GetCurrentStage();
						if GAMESTATE:IsCourseMode() then
							local stats = STATSMAN:GetCurStageStats()
							if not stats then
								return
							end
							local mpStats = stats:GetPlayerStageStats( GAMESTATE:GetMasterPlayerNumber() )
							local songsPlayed = mpStats:GetSongsPassed() + 1
							if GAMESTATE:GetPlayMode() == "PlayMode_Endless" then
								self:settextf( "%i", songsPlayed )
							else
								self:settextf( "%i / %i", songsPlayed, GAMESTATE:GetCurrentCourse():GetEstimatedNumStages() );
							end
						else
							if GAMESTATE:IsEventMode() then
								self:settextf("Event");
							else
								self:settextf("%s", ToEnumShortString(curStage));
							end
						end;
						self:diffuse(ColorLightTone(StageToColor(curStage)));
					end;
				};
				Def.BitmapText {
					Font="_plex sans Bold 24px";
					InitCommand=function(self) self:y(12):uppercase(true):skewx(-0.15) end;
					SetMessageCommand=function(self)
						local curScreen = Var "LoadingScreen";
						local curStageIndex = GAMESTATE:GetCurrentStageIndex() + 1;
						local playMode = GAMESTATE:GetPlayMode();
						local curStage = GAMESTATE:GetCurrentStage();
						if GAMESTATE:IsCourseMode() then
							self:settextf("Songs");
						else
							if GAMESTATE:IsEventMode() then
								self:settextf("Mode");
							else
								self:settextf("Stage");
							end
						end;
						self:zoom(0.5);
						self:diffuse(ColorLightTone(StageToColor(curStage)));
					end;
				};
			};
		};		
	};

	-- Score and Difficulty
	for ip, pn in ipairs(GAMESTATE:GetEnabledPlayers()) do
		local life_x_position = string.find(pn, "P1") and SCREEN_LEFT+32 or SCREEN_RIGHT-32;
		local score_x_position = string.find(pn, "P1") and SCREEN_LEFT+(SCREEN_WIDTH*0.16796875) or SCREEN_RIGHT-(SCREEN_WIDTH*0.16796875);
		local vStats = STATSMAN:GetCurStageStats():GetPlayerStageStats( pn );
		
		t[#t+1] = Def.BitmapText {
			Font="_plex sans condensed score 32px",
			InitCommand=function(self)
				self:xy(score_x_position,24)
				self:diffuse(ColorLightTone(PlayerCompColor(pn))):diffusebottomedge(PlayerColor(pn)):horizalign(center):maxwidth(SCREEN_WIDTH*0.2234375)
				if PREFSMAN:GetPreference("PercentageScoring") then
					self:settext("0.00%")
				else
					self:settext("0")
				end
			end,
			OnCommand=function(self)
				self:addy(-75):sleep(barSleepIn):decelerate(0.5):addy(75)
				if GAMESTATE:GetPlayMode() == "PlayMode_Endless" then
					self:queuecommand("UpdateTimer")
				end
			end;
			JudgmentMessageCommand=function(self)
				if GAMESTATE:GetPlayMode() == "PlayMode_Endless" then
					self:queuecommand("UpdateTimer")
				else
					self:queuecommand("RedrawScore")
				end
			end,
			UpdateTimerCommand=function(self)
				self:finishtweening():settext( SecondsToMMSSMsMs( vStats:GetAliveSeconds() ) )
				:sleep(1/60):queuecommand("UpdateTimer")
			end;
            RedrawScoreCommand=function(self)
				self:settext(GetPlScore(pn, "primary"))
			end;
			OffCommand=function(self) self:sleep(0.15):decelerate(0.3):addy(-75) end;
		};
		
		t[#t+1] = Def.ActorFrame {
		InitCommand=function(self) self:visible(GAMESTATE:IsHumanPlayer(pn)) end;
		OffCommand=function(self) self:sleep(0.15):decelerate(0.3):addy(-75) end;
			Def.ActorFrame {
				InitCommand=function(self)
					self:horizalign(center):xy(life_x_position,SCREEN_TOP+28)
				end;
				OnCommand=function(self)
					self:addy(-75):sleep(barSleepIn):decelerate(0.5):addy(75)
				end;
				-- Quad
				Def.ActorFrame {
					["CurrentSteps"..ToEnumShortString(pn).."ChangedMessageCommand"]=function(self) self:playcommand("Set") end;
						SetCommand=function(self)
								local steps_data = GAMESTATE:GetCurrentSteps(pn)
								local song = GAMESTATE:GetCurrentSong();
									if song then
										if steps_data ~= nil then
										local st = steps_data:GetStepsType();
										local diff = steps_data:GetDifficulty();
										local cd = GetCustomDifficulty(st, diff);
										self:diffuse(CustomDifficultyToColor(cd)):diffuserightedge(ColorLightTone(CustomDifficultyToColor(cd))):diffusealpha(0.8);
									end
								end
						end;			
					Def.Quad {
						InitCommand=function(self)
							self:horizalign(center):zoomto(62,56):diffuse(color("#8F8F8F")):diffusebottomedge(color("#E0E0E0"))
						end;
					};
				};
				-- Number
				Def.BitmapText {
					Font="_plex sans condensed score 32px";
					InitCommand=function(self)
						self:zoom(1):horizalign(center):maxwidth(40):y(-4)
						end;
					OnCommand=function(self)
						self:playcommand("Set"):diffusealpha(0):sleep(barSleepIn+0.3):linear(0.3):diffusealpha(1)
					end;
					["CurrentSteps"..ToEnumShortString(pn).."ChangedMessageCommand"]=function(self) self:playcommand("Set") end;
					SetCommand=function(self)
							local steps_data = GAMESTATE:GetCurrentSteps(pn)
							local song = GAMESTATE:GetCurrentSong();
								if song then
									if steps_data ~= nil then
									local st = steps_data:GetStepsType();
									local diff = steps_data:GetDifficulty();
									local cd = GetCustomDifficulty(st, diff);
									self:settext(steps_data:GetMeter())
									self:diffuse(Color.White);
								end
							end
					end;
				};
			};
		};
	end;

-- Step collection
t[#t+1]= LoadActor("stepCollector");

t[#t+1] = LoadActor("StatDisplay");

-- Pause menu
t[#t+1]= LoadActor(THEME:GetPathG("", "pause_menu"))
	
-- BPM display
if LoadModule("Config.Load.lua")("GameplayBPM","Save/OutFoxPrefs.ini") then
	t[#t+1] = LoadActor("bpmDisplay.lua");
end;


return t;