local t = LoadFallbackB();
local baseQuadWidth=614
local artistStripeHeight=48
local playerStripeHeight=56
local p2paneoffset=331

if GAMESTATE:IsCourseMode() == false then
if IsWidescreen() then
t[#t+1] = Def.ActorFrame {
-- Base quad
	Def.Quad {
		InitCommand=function(self) self:horizalign(left):vertalign(top):y(63):x(SCREEN_LEFT):zoomto(862,baseQuadWidth) end;
		OnCommand=function(self) self:diffuse(Color.Black):diffusealpha(0):decelerate(0.4):diffusealpha(0.2) end;
		OffCommand=function(self) self:sleep(0.36):decelerate(0.4):diffusealpha(0) end;
	};

-- BPM + Time Quad
	Def.Quad {
		InitCommand=function(self) self:horizalign(left):vertalign(top):x(SCREEN_CENTER_X+22):y(63):zoomto(200,206) end;
		OnCommand=function(self) self:diffuse(Color.Black):diffusealpha(0.32) end;
		OffCommand=function(self) self:sleep(0.36+.08):decelerate(0.4):diffusealpha(0) end
	};
};
end;
t[#t+1] = Def.ActorFrame {
	StandardDecorationFromFileOptional("SongTime","SongTime") .. {
	SetCommand=function(self)
		local curSelection = nil;
		local length = 0.0;
		local ColorTable = {
			Reset = { color("#FFFFFF"), color("#EEEEEE") },
			-- why do we have this
			Autogen = { Color("Blue"), color("#FFFFFF") },
			Long = { color("#29739b"), color("#FFFFFF") },
			Marathon = { color("#29419b"), color("#FFFFFF") },
		};
		self:diffuse( ColorTable["Reset"][1] ):diffusebottomedge( ColorTable["Reset"][2] )
		curSelection = GAMESTATE:GetCurrentSong();
		if curSelection then
			length = curSelection:MusicLengthSeconds();
			if curSelection:IsLong() then
				self:diffuse( ColorTable["Long"][1] )
				:diffusebottomedge( ColorTable["Long"][2] )
			elseif curSelection:IsMarathon() then
				self:diffuse( ColorTable["Marathon"][1] )
				:diffusebottomedge( ColorTable["Marathon"][2] )
			end
		end;
		self:settext( SecondsToMSS(length) );
		if length > 3600 then
			self:settext( SecondsToHHMMSS(length) );
		end
	end;
	CurrentSongChangedMessageCommand=function(self) self:playcommand("Set") end;
	CurrentCourseChangedMessageCommand=function(self) self:playcommand("Set") end;
	};

	Def.BitmapText{
		Font="_plex sans medium 24px";
		InitCommand=function(self) self:horizalign(left):zoom(0.8):uppercase(true)
		:x(IsWidescreen() and SCREEN_CENTER_X+46 or SCREEN_CENTER_X-470):y(IsWidescreen() and SCREEN_CENTER_Y-270+30 or SCREEN_CENTER_Y-95+30)
		end;
		OnCommand=function(self) self:playcommand("Set"):diffusealpha(0):decelerate(0.2):diffusealpha(1) end;
		OffCommand=function(self) self:decelerate(0.2):diffusealpha(0) end;
		SetCommand=function(self)
			self:settext(THEME:GetString("MusicWheel","LengthText"));
		end;
	};
	
	StandardDecorationFromFileOptional("BPMDisplay","BPMDisplay");
	
	Def.BitmapText{
		Font="_plex sans medium 24px";
		InitCommand=function(self) self:horizalign(left):zoom(0.8):uppercase(true)
		:x(IsWidescreen() and SCREEN_CENTER_X+46 or SCREEN_CENTER_X-470+120):y(IsWidescreen() and SCREEN_CENTER_Y-205+30 or SCREEN_CENTER_Y-95+30) end;
		OnCommand=function(self) self:playcommand("Set"):diffusealpha(0):sleep(0.12):decelerate(0.2):diffusealpha(1) end;
		OffCommand=function(self) self:sleep(0.12):decelerate(0.2):diffusealpha(0) end;	
		SetCommand=function(self)
			self:settext("BPM");
		end;
	};

	Def.ActorFrame {
	InitCommand=function(self) self:x(IsWidescreen() and SCREEN_CENTER_X+46 or SCREEN_CENTER_X-470+160+90)
	:y(IsWidescreen() and SCREEN_CENTER_Y-140 or SCREEN_CENTER_Y-95) end;
	OnCommand=function(self) self:diffusealpha(0):sleep(0.12*2):decelerate(0.2):diffusealpha(1) end;
	OffCommand=function(self) self:sleep(0.12*2):decelerate(0.2):diffusealpha(0) end;	
		Def.BitmapText {
			Font="_plex sans Bold 24px";
			InitCommand=function(self) self:horizalign(left):zoom(1):uppercase(true):maxwidth(IsWidescreen() and 160 or 130):addy(2) end;
			OnCommand=function(self) self:playcommand("Set") end;
			CurrentSongChangedMessageCommand=function(self) self:finishtweening():playcommand("Set") end;
			CurrentCourseChangedMessageCommand=function(self) self:finishtweening():playcommand("Set") end;
			ChangedLanguageDisplayMessageCommand=function(self) self:finishtweening():playcommand("Set") end;
			SetCommand=function(self)
			  local song = GAMESTATE:GetCurrentSong();
			   if song then
					if song:GetGenre() == "" then
						self:settext("N/A");
						self:diffusealpha(0.5);
					else
						self:settext(song:GetGenre()); 
						self:diffusealpha(1);
					end;
					self:playcommand("Refresh");
				else
					self:settext("N/A");
					self:diffusealpha(0.5);
					self:playcommand("Refresh");
			   end
			end;
		};			
		Def.BitmapText {
			Font="_plex sans medium 24px";
			InitCommand=function(self) self:horizalign(left):zoom(0.8):uppercase(true):addy(30) end;
			OnCommand=function(self) self:playcommand("Set") end;
			SetCommand=function(self)
				self:settext(THEME:GetString("MusicWheel","GenreText"));
			end;
		};	
	};
};
	
-- Difficulty List Quad
if IsWidescreen() then
t[#t+1] = Def.Quad {
	InitCommand=function(self) self:horizalign(left):vertalign(top):xy(SCREEN_CENTER_X+22,63+206):zoomto(200,408) end;
	OnCommand=function(self) self:diffuse(Color.Black):diffusealpha(0):decelerate(0.4):diffusealpha(0.5) end;
	OffCommand=function(self) self:sleep(0.36+.12):decelerate(0.4):diffusealpha(0) end;
	}
else
t[#t+1] = Def.Quad {
	InitCommand=function(self) self:horizalign(left):vertalign(top):xy(SCREEN_CENTER_X-81,64-4):zoomto(143,257) end;
	OnCommand=function(self) self:diffuse(Color.Black):diffusealpha(0):decelerate(0.4):diffusealpha(0.5) end;
	OffCommand=function(self) self:sleep(0.36+.12):decelerate(0.4):diffusealpha(0) end;
	}
end;

t[#t+1] = StandardDecorationFromFileOptional("DifficultyList","DifficultyList");

----- /
-- Long?
----- /	
t[#t+1] = LoadActor("longIndicator") .. {
	InitCommand=function(self)
		self:horizalign(center):vertalign(middle):x(SCREEN_CENTER_X-90):y(SCREEN_CENTER_Y-268):draworder(50):diffusealpha(0)
		if IsWidescreen() == false then
			self:addx(-75):addy(-8):zoom(0.75)
		end;
	end;
}

----- /
-- Player 1 info pane
----- /	
t[#t+1] = LoadActor("panels");

----- /
-- Artist Text
----- /	
t[#t+1] = Def.ActorFrame {
	InitCommand=function(self) self:horizalign(left):x(SCREEN_LEFT+10):y(IsWidescreen() and SCREEN_CENTER_Y-68 or SCREEN_CENTER_Y-150) end;
	OffCommand=function(self) self:sleep(0.24):decelerate(0.4):diffusealpha(0) end;
	Def.BitmapText {
		Font="_plex sans Bold 24px";		
		InitCommand=function(self) self:horizalign(left):uppercase(true):maxwidth(100):queuecommand("Set") end;
		ChangedLanguageDisplayMessageCommand=function(self) self:queuecommand("Set") end; 
		SetCommand=function(self)
			self:settext(THEME:GetString("MusicWheel","ArtistText") .. ":");
		end;
	};

	Def.BitmapText {
		Font="_plex sans medium 24px";
		InitCommand=function(self) self:horizalign(left):addx(106):maxwidth(IsWidescreen() and 520 or 266):queuecommand("Set") end;
		OnCommand=function(self) self:playcommand("Set") end;
		CurrentSongChangedMessageCommand=function(self) self:finishtweening():playcommand("Set") end;
		CurrentCourseChangedMessageCommand=function(self) self:finishtweening():playcommand("Set") end;
		ChangedLanguageDisplayMessageCommand=function(self) self:finishtweening():playcommand("Set") end;
		SetCommand=function(self)
		   local song = GAMESTATE:GetCurrentSong();
		   if song then
				self:settext(song:GetDisplayArtist()); 
				self:playcommand("Refresh");
			else
				self:settext("");
				self:playcommand("Refresh");
		   end
		end;
	};
};
end;
t[#t+1] = StandardDecorationFromFileOptional("AlternateHelpDisplay","AlternateHelpDisplay");

----- /
-- Options prompt
----- /
t[#t+1] = Def.ActorFrame{
	Def.Quad {
		InitCommand=function(self) self:draworder(160):FullScreen():diffuse(color("0,0,0,1")):diffusealpha(0) end;
		ShowPressStartForOptionsCommand=function(self) self:decelerate(0.3):diffusealpha(0.3) end;
		ShowEnteringOptionsCommand=function(self) self:sleep(0.4):decelerate(0.3):diffusealpha(0) end;
		HidePressStartForOptionsCommand=function(self) self:sleep(0.4):decelerate(0.3):diffusealpha(0) end;
	};

	Def.ActorFrame {
		OnCommand=function(self) self:visible(false) end;
		ShowPressStartForOptionsCommand=function(self) self:visible(true):diffusealpha(0):vertalign(bottom):y(SCREEN_BOTTOM+120):decelerate(0.25):addy(-120):diffusealpha(1) end;		
		ShowEnteringOptionsCommand=function(self) self:sleep(0.4):decelerate(0.3):addy(120):diffusealpha(0) end;
		HidePressStartForOptionsCommand=function(self) self:sleep(0.4):decelerate(0.3):addy(120):diffusealpha(0) end;
		
		Def.Quad{
			InitCommand=function(self) self:vertalign(bottom):zoomto(SCREEN_WIDTH,120):x(SCREEN_CENTER_X):diffuse(color("#1D3679")):diffusealpha(0) end;
			ShowPressStartForOptionsCommand=function(self) self:diffusealpha(1) end;
		};
		StandardDecorationFromFileOptional("SongOptions","SongOptionsText") .. {
			ShowPressStartForOptionsCommand=THEME:GetMetric(Var "LoadingScreen","SongOptionsShowCommand");
			ShowEnteringOptionsCommand=THEME:GetMetric(Var "LoadingScreen","SongOptionsEnterCommand");
			HidePressStartForOptionsCommand=THEME:GetMetric(Var "LoadingScreen","SongOptionsHideCommand");
		};
	};
};


return t;