local t = Def.ActorFrame {};

t[#t+1] = Def.ActorFrame {
	OnCommand=function(self)
		self:addy(-104):decelerate(0.5):addy(104)
	end,
	OffCommand=function(self)
		self:sleep(0.175):decelerate(0.4):addy(-105)
	end;
	Def.Quad {
		InitCommand=function(self)
			self:zoomto(418,64):diffuse(color("#000000")):diffusealpha(0.9):vertalign(top):horizalign(right):x(SCREEN_RIGHT):y(0)
		end;
	};
	-- Quad behind sort order
	Def.Quad {
		InitCommand=function(self)
			self:zoomto(418,64):diffuse(color("#294DAD")):diffusealpha(0.6):vertalign(top):horizalign(right):x(SCREEN_RIGHT):y(0)
		end;		
	};
	-- Glow on order change
	Def.Quad {
		InitCommand=function(self)
			self:zoomto(418,64):diffuse(color("#8592d1")):diffusealpha(0):vertalign(top):horizalign(right):x(SCREEN_RIGHT):y(0)
		end;
		SortOrderChangedMessageCommand=function(self) self:finishtweening():diffusealpha(0.4):decelerate(0.4):diffusealpha(0) end;
	};
	Def.Quad {
		InitCommand=function(self)
			self:zoomto(418,2):diffusealpha(0):vertalign(bottom):horizalign(right):x(SCREEN_RIGHT):y(63)
			self:diffuse(color("#C7F9FF")):diffuserightedge(color("#B9CDFD")):diffusealpha(0.5)
		end;
	};	
};

-- Sort order
t[#t+1] = Def.ActorFrame {
	OnCommand=function(self) self:diffusealpha(0):sleep(0.5):smooth(0.3):diffusealpha(1) end;
	OffCommand=function(self) self:smooth(0.175):diffusealpha(0) end;
    Def.Sprite {
		Texture=THEME:GetPathG("ScreenSelectMusic","sort icon");
		InitCommand=function(self) self:xy(SCREEN_RIGHT-380,SCREEN_TOP+30) end;
	};
	Def.BitmapText {
		Font="_plex sans Bold 24px";	
		InitCommand=function(self) self:xy(SCREEN_RIGHT-340,SCREEN_TOP+30):zoom(1):maxwidth(200):diffuse(Color.White):diffusebottomedge(color("#A7C7FF")):uppercase(true):horizalign(left):maxwidth(240) end;
		OnCommand=function(self) self:queuecommand("Set") end;
		SortOrderChangedMessageCommand=function(self) self:queuecommand("Set") end;
		ChangedLanguageDisplayMessageCommand=function(self) self:queuecommand("Set") end;
		SetCommand=function(self)
		   local sortorder = GAMESTATE:GetSortOrder();
		   local song = GAMESTATE:GetCurrentSong();
		   if sortorder then
				self:finishtweening():settext(SortOrderToLocalizedString(sortorder));
				self:queuecommand("Refresh")
			else
				self:settext("");
				self:queuecommand("Refresh");
		   end
		end;
	};
};

-- Stage display
if not GAMESTATE:IsCourseMode() then
t[#t+1] = Def.ActorFrame {
	LoadActor(THEME:GetPathG("ScreenWithMenuElements", "StageDisplay")) .. {
		InitCommand=function(self) self:xy(SCREEN_RIGHT-520,SCREEN_TOP+32) end;
		OnCommand=function(self)
			if PREFSMAN:GetPreference("MenuTimer") == true then
				self:addx(-220)
			end;
			self:diffusealpha(0):sleep(0.5):smooth(0.3):diffusealpha(1) 
		end;
		OffCommand=function(self) self:smooth(0.175):diffusealpha(0) end;
	}
}
end;

for p in ivalues(PlayerNumber) do
	setenv("GoalAchieved"..p , false)
end


return t