local playMode = GAMESTATE:GetPlayMode()
local sStage = ""
sStage = GAMESTATE:GetCurrentStage()

if playMode ~= 'PlayMode_Regular' and playMode ~= 'PlayMode_Rave' and playMode ~= 'PlayMode_Battle' then
  sStage = playMode;
end;
local curStage = GAMESTATE:GetCurrentStage();

local titleFadeIn = 0.6

local t = Def.ActorFrame {};
	-- BG animation
	t[#t+1] = Def.Quad {
		InitCommand=function(self)
			self:zoomto(SCREEN_WIDTH,1):vertalign(top):x(SCREEN_CENTER_X):y(SCREEN_TOP)
			self:diffuse(Color.Black)
		end;
		OnCommand=function(self)
			self:decelerate(0.6):zoomto(SCREEN_WIDTH,SCREEN_HEIGHT)
		end;
	  };
	-- Scanline
	t[#t+1] = Def.Quad {
		InitCommand=function(self)
			self:zoomto(SCREEN_WIDTH,5):vertalign(top):x(SCREEN_CENTER_X):y(SCREEN_TOP)
			self:diffuse(ColorLightTone(StageToColor(curStage)))
		end;
		OnCommand=function(self)
			self:decelerate(0.6):y(SCREEN_BOTTOM)
		end;
	  };
  
	-- Animated strip texture
    t[#t+1] = Def.Sprite{
		Texture="_wave",
		OnCommand=function(self) self:diffuse(StageToColor(curStage)):diffusealpha(0):sleep(titleFadeIn+0.4):diffusealpha(1):linear(1):diffusealpha(0) end;
		InitCommand=function(self) 
			self:xy(SCREEN_CENTER_X,SCREEN_CENTER_Y):diffusealpha(0.4)
		end;
	};	
	t[#t+1] = Def.ActorFrame {	
		OnCommand=function(self) self:diffuse(ColorLightTone(StageToColor(curStage))):diffusealpha(0):sleep(titleFadeIn+0.4):diffusealpha(1):linear(2.8):diffusealpha(0) end;
		Def.Sprite{
			Texture="_strip",
			InitCommand=function(self) 
				self:xy(SCREEN_CENTER_X,SCREEN_CENTER_Y-100):zoomto(SCREEN_WIDTH,32)
				self:fadeleft(1):faderight(1) 
			end;
			OnCommand=function(self) 
				self:customtexturerect(0,0,1,1):texcoordvelocity(0.1,0) 
			end;
		};		
		Def.Sprite{
			Texture="_strip",
			InitCommand=function(self) 
				self:xy(SCREEN_CENTER_X,SCREEN_CENTER_Y+100):zoomto(SCREEN_WIDTH,32)
				self:fadeleft(1):faderight(1) 
			end;			
			OnCommand=function(self) 
				self:customtexturerect(0,0,1,1):texcoordvelocity(-0.1,0)
			end;
		};
	};
	-- Difficulty and author credits
	for ip, pn in ipairs(GAMESTATE:GetEnabledPlayers()) do
	local credit_position = string.find(pn, "P1") and SCREEN_LEFT+20 or SCREEN_RIGHT-20;
	local credit_alignment = string.find(pn, "P1") and left or right;
	t[#t+1] = Def.ActorFrame {
		InitCommand=function(self) self:xy(credit_position,SCREEN_BOTTOM-100) end;
		OnCommand=function(self)
			self:diffusealpha(0):sleep(titleFadeIn):smooth(0.4):diffusealpha(1):sleep(2.3):decelerate(0.5):diffusealpha(0)
		end;
			Def.BitmapText {
				Font="_plex sans medium 24px";
				InitCommand=function(self)
					self:horizalign(credit_alignment)
				end;
				OnCommand=function(self)
					self:playcommand("Set")
				end;
				SetCommand=function(self)
				local steps_data = GAMESTATE:GetCurrentSteps(pn)
				local song = GAMESTATE:GetCurrentSong();
				if song then 
					if steps_data ~= nil then
						local st = steps_data:GetStepsType();
						local diff = steps_data:GetDifficulty();
						local courseType = GAMESTATE:IsCourseMode() and SongOrCourse:GetCourseType() or nil;
						local cd = GetCustomDifficulty(st, diff, courseType);
							if steps_data:IsAnEdit() then
								self:settext(steps_data:GetChartName())
							else
								self:settext(THEME:GetString("CustomDifficulty",ToEnumShortString(diff)));
							end;
						self:diffuse(ColorLightTone(CustomDifficultyToColor(cd)));
						self:strokecolor(ColorDarkTone(CustomDifficultyToColor(cd)));
					else
						self:settext("")
					end
				else
					self:settext("")
				end
			 end;
			};
			Def.BitmapText {
				Font="_plex sans medium 24px";
				InitCommand=function(self)
					self:y(24):horizalign(credit_alignment):zoom(0.75):diffuse(Color.White):strokecolor(Color.Black):maxwidth(300)
				end;
				OnCommand=function(self)
					self:playcommand("Set")
				end;
				SetCommand=function(self)
				local steps_data = GAMESTATE:GetCurrentSteps(pn)
				local song = GAMESTATE:GetCurrentSong();
				if song then
					if steps_data ~= nil then
						self:settext(steps_data:GetAuthorCredit())
					else
						self:settext("")
					end
				else
					self:settext("")
				end
			 end
			};
		};
	end;

t[#t+1] = Def.ActorFrame {
	InitCommand=function(self)
		self:xy(SCREEN_CENTER_X,SCREEN_BOTTOM-100)
	end;
	OnCommand=function(self)
		self:diffusealpha(0):sleep(titleFadeIn):smooth(0.4):diffusealpha(1):sleep(2.3):decelerate(0.5):diffusealpha(0)
		end;
	Def.BitmapText {
		Font="_ibm plex sans semibold 36px";
		Text=GAMESTATE:IsCourseMode() and GAMESTATE:GetCurrentCourse():GetDisplayFullTitle() or GAMESTATE:GetCurrentSong():GetTranslitFullTitle();
		InitCommand=function(self)
			self:diffuse(Color.White):strokecolor(Color.Black):zoom(0.75):maxwidth(SCREEN_WIDTH*0.75)
		end;
	};
	Def.BitmapText {
		Font="_plex sans medium 24px";
		Text=GAMESTATE:IsCourseMode() and ToEnumShortString( GAMESTATE:GetCurrentCourse():GetCourseType() ) or GAMESTATE:GetCurrentSong():GetDisplayArtist();
		InitCommand=function(self)
			self:diffuse(Color.White):strokecolor(Color.Black):zoom(0.75):maxwidth(SCREEN_WIDTH*0.75):y(26)
		end;
	};
};

-- Stage graphic
local stage_num_actor= THEME:GetPathG("ScreenStageInformation", "Stage " .. ToEnumShortString(sStage), true)
if stage_num_actor ~= "" and FILEMAN:DoesFileExist(stage_num_actor) then
	stage_num_actor= LoadActor(stage_num_actor)
else
	-- Midiman:  We need a "Stage Next" actor or something for stages after
	-- the 6th. -Kyz
	stage_num_actor= Def.BitmapText{
		Font= "_ibm plex sans semibold 36px";
		Text= thified_curstage_index(false) .. " Stage",
		InitCommand= function(self)
			self:zoom(1.5)
			self:diffuse(StageToColor(curStage));
			self:diffuserightedge(ColorLightTone(StageToColor(curStage)));
		end
	}
end

t[#t+1] = Def.ActorFrame {
	InitCommand=function(self) self:xy(SCREEN_CENTER_X,SCREEN_CENTER_Y) end;
	
	stage_num_actor .. {
		InitCommand=function(self) self:zoom(1):diffusealpha(1) end;
		OnCommand=function(self) 
			self:diffusealpha(0):zoomx(1.25):sleep(titleFadeIn):bouncebegin(0.4):bounceend(0.4):diffusealpha(1):zoomx(1)
			self:sleep(1.9):decelerate(0.5):diffusealpha(0):zoom(0.9) 
		end;
	};
};


return t;